'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _enzymeAdapterReact = require('enzyme-adapter-react-16');

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

var _enzymeToJson = require('enzyme-to-json');

var _enzymeToJson2 = _interopRequireDefault(_enzymeToJson);

var _injectWeb = require('../injectWeb3');

var _injectWeb2 = _interopRequireDefault(_injectWeb);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MyComponent = function MyComponent() {
  return _react2.default.createElement(
    'div',
    { className: 'test' },
    'Test'
  );
};

(0, _enzyme.configure)({ adapter: new _enzymeAdapterReact2.default() });

describe('when loading', function () {
  // injectWeb3(MyComponent) will by default show the loading component here,
  // because this.state.web3 is initialized to null in the HOC. See 'when
  // loaded' tests to see how to test a loaded MyComponent
  it('should return null by default', function () {
    var WrappedComponent = (0, _injectWeb2.default)()(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
  });

  it('should return the loading function if present', function () {
    var WrappedComponent = (0, _injectWeb2.default)({
      loading: function loading() {
        return _react2.default.createElement(
          'div',
          null,
          'loading from function...'
        );
      }
    })(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
  });

  it('should return the loading component if present', function () {
    var Loading = function (_Component) {
      (0, _inherits3.default)(Loading, _Component);

      function Loading() {
        (0, _classCallCheck3.default)(this, Loading);
        return (0, _possibleConstructorReturn3.default)(this, (Loading.__proto__ || (0, _getPrototypeOf2.default)(Loading)).apply(this, arguments));
      }

      (0, _createClass3.default)(Loading, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            'div',
            null,
            'loading from component...'
          );
        }
      }]);
      return Loading;
    }(_react.Component);

    var WrappedComponent = (0, _injectWeb2.default)({
      loading: Loading
    })(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
  });
});

describe('when loaded', function () {
  it('should render correctly', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var WrappedComponent, wrapper;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            WrappedComponent = (0, _injectWeb2.default)()(MyComponent);
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));
            _context.next = 4;
            return wrapper.instance().componentWillMount();

          case 4:
            wrapper.update();

            expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should have web3 as props', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var WrappedComponent, wrapper, InnerComponent;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            WrappedComponent = (0, _injectWeb2.default)()(MyComponent);
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));
            _context2.next = 4;
            return wrapper.instance().componentWillMount();

          case 4:
            InnerComponent = wrapper.update().find(MyComponent);


            expect(InnerComponent.props().web3.currentProvider.host).toBe('http://localhost:8545');

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));
});