'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _enzymeAdapterReact = require('enzyme-adapter-react-16');

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

var _injectWeb = require('./injectWeb3');

var _injectWeb2 = _interopRequireDefault(_injectWeb);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MyComponent = function MyComponent() {
  return _react2.default.createElement(
    'div',
    null,
    'Test'
  );
};

(0, _enzyme.configure)({ adapter: new _enzymeAdapterReact2.default() });

describe('when loading', function () {
  beforeAll(function () {
    Object.defineProperty(document, 'readyState', {
      value: 'loading',
      writable: true
    });
    window.addEventListener = function (_, resolve) {
      return setTimeout(resolve, 200);
    };
  });

  it('should return null by default', function () {
    var WrappedComponent = (0, _injectWeb2.default)()(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect(wrapper).toMatchSnapshot();
  });

  it('should return the loading function if present', function () {
    var WrappedComponent = (0, _injectWeb2.default)({
      loading: function loading() {
        return _react2.default.createElement(
          'div',
          null,
          'loading from function...'
        );
      }
    })(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect(wrapper).toMatchSnapshot();
  });

  it('should return the loading component if present', function () {
    var Loading = function (_Component) {
      (0, _inherits3.default)(Loading, _Component);

      function Loading() {
        (0, _classCallCheck3.default)(this, Loading);
        return (0, _possibleConstructorReturn3.default)(this, (Loading.__proto__ || (0, _getPrototypeOf2.default)(Loading)).apply(this, arguments));
      }

      (0, _createClass3.default)(Loading, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            'div',
            null,
            'loading from component...'
          );
        }
      }]);
      return Loading;
    }(_react.Component);

    var WrappedComponent = (0, _injectWeb2.default)({
      loading: Loading
    })(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect(wrapper).toMatchSnapshot();
  });

  afterAll(function () {
    Object.defineProperty(document, 'readyState', {
      value: 'complete',
      writable: true
    });
    // TODO restore window.addEventListener?
  });
});

describe('when loaded', function () {
  it('should render correctly', function () {
    var WrappedComponent = (0, _injectWeb2.default)()(MyComponent);
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null));

    expect(wrapper).toMatchSnapshot();
  });

  // it('should have web3 as props', () => {
  //   const WrappedComponent = injectWeb3()(MyComponent);
  //   const wrapper = shallow(<WrappedComponent />);

  //   expect(wrapper.props.web3.currentProvider.host).toBe(
  //     'http://localhost:8545'
  //   );
  // });
});